﻿# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2010 E.Samyn - esamyn@gmail.com
# Author: E.Samyn
#
# This file is part of the project_soft2wiki module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; 
# If not, see <http://www.gnu.org/licenses/> or  write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import fields, osv
import pooler

class project_software_functionality(osv.osv):
    _name = "software.functionality"
    _inherit = 'software.functionality'
    _description = "functionality of a software"
    
    # Add or modify wiki page ; update state
    def on_valid(self, cr, uid, ids, context=None):
		wiki_pool = self.pool.get('wiki.wiki')
		wiki_groups_pool = self.pool.get('wiki.groups')
		print "on_valid"
		for o in self.browse(cr, uid, ids):
			# If functionality has block : get wiki group id (create if doesn't exist)
			wiki_group_id = 0
			if(o.functionality_block.id):
				print "func has block"
				block_id = wiki_groups_pool.search(cr, uid,[('name','=',o.functionality_block.name)])
				print block_id
				if(block_id):
					print "trouvé"
					print block_id[0]
					wiki_group_id = block_id[0]
				else:
					print "pas trouvé"
					wiki_group_id = wiki_groups_pool.create(cr, uid, {
					'name': o.functionality_block.name,
					#'home' : o.functionality_keywords,
					})
					print wiki_group_id
			# If functionality as a related wiki_id 
			if (o.wiki_id):
				print "update"
				print "wiki_page_id: ",o.wiki_id.id
				wiki_pool.write(cr, uid, [o.wiki_id.id], {
					'name': o.name,
					'tags' : o.functionality_keywords,
					'text_area' : o.functionality_description+"<br>"+o.functionality_implem_method+"<br>"+o.functionality_gui+"<br>"+o.functionality_use+"<br>"+o.functionality_scenario, # description
					'summary' : o.functionality_description,
					'group_id' : wiki_group_id
#					'parent_id' : o.functionality_parent.wiki_id.id, # ATTENTION mapping : id func parent <> id xiki parent
				})
				self.write(cr, uid, [o.id], {'state': 'valid'})
			else:
				print "new"
				wiki_id = wiki_pool.create(cr, uid, {
					'name': o.name,
					'tags' : o.functionality_keywords,
					'text_area' : o.functionality_description+"<br>"+o.functionality_implem_method+"<br>"+o.functionality_gui+"<br>"+o.functionality_use+"<br>"+o.functionality_scenario, # description
					'summary' : o.functionality_description,
					'group_id' : wiki_group_id
#					'parent_id' : o.functionality_parent.wiki_id.id, # ATTENTION mapping : id func parent <> id xiki parent
				})				
				self.write(cr, uid, [o.id], {'state': 'valid','wiki_id':wiki_id})
		return True

	# Delete / set draft state of wiki page ? if delete : remove link to wiki page id
    def on_obsolete(self, cr, uid, ids, context=None):
		print "on_obsolete"
		for o in self.browse(cr, uid, ids):
			if (o.wiki_id):
				print "cascade delete for parents ?"
				self.pool.get('wiki.wiki').unlink(cr,uid,[o.wiki_id.id])
			self.write(cr, uid, [o.id], {'state': 'obsolete'})
		return True
			
    _columns = {
    	'wiki_id': fields.many2one('wiki.wiki', 'Related wiki page', help="Wiki page built and updated from this functionality", readonly=1),
    }	
		        		
project_software_functionality()
